(*
 Environment for defined expressions
 
 author: Christian Mueller
*)

local 
    open Info AbstractSyntax Binarymap Support
in

exception IdNotFound of info * string

type env = (string,Exp) dict
	   
fun create () = mkDict (String.compare)
		 
fun add (env,s,e)  = insert (env,s,setIdentifier s e)

fun delete (env,s) = #1 (remove (env,s))
		    
fun get (env,info,s) = find(env,s) handle _ => raise IdNotFound (info,s)

fun getList env = listItems env

fun find (env,e) =
    let
	exception Found of string
    in
	(app (fn (k,e') => if LambdaCube.equiv (e,e') then raise Found k 
			   else ()) env; 
	 NONE) 
	handle Found s => SOME s
    end
	
end
