(*
 This file contains various stuff that is needed by
 all other files
 
 author: Christian Mueller
*)

(* 
  info field for lexer tokens and parse tree 

  info = line number * first character * file name * (identifier option)
*)

type info = int * int * string * (string option)

(* context management for transformation into de Bruijn *)

type context = string list

fun name2index s ctx =
    let
        fun n2i s nil c = ~1 (* free variable *)
          | n2i s (x::ctx) c = if s=x then c else n2i s ctx (c+1)
    in
        n2i s ctx 0
    end

val defaultIdent = "it"

(* exception to exit the interpreter *)

exception ExitToplevel

(* 
   excpetion that the parser throws if it encounters double definitions of a 
   label in one field
*)

exception LabelError of int * int

exception Help
