(* -*-sml-*- *)

(* ----------------------------------------------------------------------
 * This file contains some test cases for the interpreter in "CC" mode. 
 * The other test files can also be used in CC mode.
 *
 * author: Christian Mueller
 * ---------------------------------------------------------------------*)     

switch tm cc

(* 
   1. first nice examples for dependent types: a function whose type
      of the second argument depends on the value of the first 
*)

rdef DType1 = \b:Bool. if b then Int else Bool

rdef f = \b:Bool.\x:DType1 b.x

rdef result_11 = 2 + f true 3
rdef result_12 = not (f false true)

(*  2. In CC more powerful records are allowed *)

def R = { T1 = Int, T2 = Bool }

def F = \r:{T1:*,T2:*}. r@T1 -> r@T2

rdef T = F R

def f = (\x:Int. x<<0) as T

(*  3. you can also mix types and terms in a record *)

def RR = { x=3, T=Int }

def v = (RR@x) as (RR@T)